local BigBrother = _G.BigBrother
assert(BigBrother, "BigBrother_Ready requires BigBrother")

local frame = CreateFrame("Frame")

local enabled = false

local ldbdata
local function setIcon()
	ldbdata.icon = enabled and [[Interface\RAIDFRAME\ReadyCheck-Ready]] or [[Interface\RAIDFRAME\ReadyCheck-NotReady]]
	ldbdata.text = enabled and "On" or "Off"
end

local function enable()
	frame:RegisterEvent("READY_CHECK")
	enabled = true
	setIcon()
	_G.BigBrother_ReadyDisabled = not enabled
end

local function disable()
	frame:UnregisterEvent("READY_CHECK")
	enabled = false
	setIcon()
	_G.BigBrother_ReadyDisabled = not enabled
end

local function onevent(self, event)
	if event == "READY_CHECK" then
		if UnitInRaid("player") then
			BigBrother:QuickCheck("RAID")
		end
	elseif event == "ADDON_LOADED" then
		frame:UnregisterEvent("ADDON_LOADED")
		if not _G.BigBrother_ReadyDisabled then
			enable()
		else
			setIcon()
		end
	end
end
frame:RegisterEvent("ADDON_LOADED")
frame:SetScript("OnEvent", onevent)

local function toggleEnabled()
	if enabled then
		disable()
	else
		enable()
	end
	return enabled
end

ldbdata = {
	type = "launcher",
	OnClick = function(_, msg)
			if msg == "LeftButton" then
				toggleEnabled()
			end
		end,
	label = "BigBrother_Ready",
}

LibStub("LibDataBroker-1.1"):NewDataObject("BigBrother_Ready", ldbdata)
